<?php
    //Konfig:
    $mypage = 'wildcards';
    $REX['ADDON']['rxid'][$mypage] = '885489489714132987189513248797879874515';
    $REX['ADDON']['page'][$mypage] = $mypage;
    $REX['ADDON']['name'][$mypage] = 'Wildcards';
    $REX['ADDON']['perm'][$mypage] = 'wildcards[]';
    $REX['ADDON']['version'][$mypage] = '1.7';
    $REX['ADDON']['author'][$mypage] = 'Tobias Jörg';

    // Berechtigungen
    $REX['PERM'][] = 'wildcards[]';
    $REX['PERM'][] = 'wildcards[translator_only]';


    //inkludiert die Settings-Datei (z.b. zum Speichern der Farben)
    $settings = $REX['INCLUDE_PATH'] . '/addons/' . $mypage . '/data/settings.data.inc.php';
    if (file_exists($settings)) {
        include $settings;
    }

    //Backend? go ->
    if ($REX['REDAXO']) {
        //inkludiert die Sprachen
        $I18N->appendFile($REX['INCLUDE_PATH'] . '/addons/' . $mypage . '/lang/');

        //Berechtigungen (else Bedeutet in dem Fall -> Translator)
        if (!(isset($REX['USER']) && !$REX['USER']->isAdmin() && $REX['USER']->hasPerm('wildcards[translator_only]'))) {
            //Unterseiten Admin/kein Übersetzer
            $REX['ADDON']['pages'][$mypage] = array(
                array('', $I18N->msg('wildcards_nav_table')),
                array('add', $I18N->msg('wildcards_nav_add')),
                array('users', $I18N->msg('wildcards_nav_users')),
                array('settings', $I18N->msg('wildcards_nav_settings')),
                array('info', $I18N->msg('wildcards_nav_info'))
            );
        }
    }


    //Frontend? go ->   
    if (!$REX['REDAXO'])
    {   
        rex_register_extension('OUTPUT_FILTER', 'replaceWildcards');
    }
    // Platzhalter ersetzen Funktion
    function replaceWildcards($params)
    {
        global $REX, $wildcard_default_clang_activate, $wildcard_default_clang;
        $content = $params['subject'];

        if($wildcard_default_clang_activate == 1)
        {
            $sql = new rex_sql();
            // $sql->debugsql = true;
            $sql->setQuery('SELECT clang_'.$REX['CUR_CLANG'].', clang_'.$wildcard_default_clang.', wildcard FROM rex_wildcards');
            
            $srch = array();
            $rplc = array();
            $rows = $sql->getRows();
            for ($i = 0; $i < $rows; $i ++)
            {
                $srch[] = $sql->getValue('wildcard');
                if($sql->getValue('clang_'.$REX['CUR_CLANG'].'') == "")
                {
                    $rplc[] = nl2br($sql->getValue('clang_'.$wildcard_default_clang.''));
                }
                else
                {
                    $rplc[] = nl2br($sql->getValue('clang_'.$REX['CUR_CLANG'].''));
                }
                $sql->next();
            }
            
            return str_replace($srch, $rplc, $content);
        }

        if($wildcard_default_clang_activate == 0)
        {
            $sql = new rex_sql();
            // $sql->debugsql = true;
            $sql->setQuery('SELECT clang_'.$REX['CUR_CLANG'].', wildcard FROM rex_wildcards');
            
            $srch = array();
            $rplc = array();
            $rows = $sql->getRows();
            for ($i = 0; $i < $rows; $i ++)
            {
                $srch[] = $sql->getValue('wildcard');
                $rplc[] = nl2br($sql->getValue('clang_'.$REX['CUR_CLANG'].''));
                $sql->next();
            }
            
            return str_replace($srch, $rplc, $content);
        }        
    }

    // EP beim Hinzufügen einer neuen Sprache
    rex_register_extension('CLANG_ADDED', 'rex_wildcards_clang_added');
    function rex_wildcards_clang_added($params)
    {
        //Clang $id:
        $id = (int)$params['id'];
        //startet SQL
        $sql = new rex_sql();
        //fügt Spalte mit der clang_id hinzu
        $sql->setQuery('ALTER TABLE rex_wildcards ADD clang_'.$id.' varchar(255) DEFAULT ""');      
    }


    // EP beim Löschen einer neuer Sprache
    rex_register_extension('CLANG_DELETED', 'rex_wildcards_clang_delete');
    function rex_wildcards_clang_delete($params)
    {
        //Clang $id (int un string):
        $id = (int)$params['id'];
        $clang_id = (string)$params['id'];
        //startet SQL
        $sql = new rex_sql();
        //löscht Spalte mit der clang_id
        $sql->setQuery('ALTER TABLE rex_wildcards DROP COLUMN clang_'.$id);

        //vernichte die Sprache im wildcards_rights string
        //dafür sammle alle user
        $all_user_query = "SELECT * FROM rex_user";
        $sql->setQuery($all_user_query);
        //Schleife über alle
        for($i = 0; $i < $sql->getRows(); $i++){
            //get rights und user_id
            $wildcards_rights = $sql->getValue("wildcards_rights");
            $user_id = $sql->getValue("user_id");
            //schau nach, ob die (gelöschte) clang_id in dem rights drinne ist
            if(strpos($wildcards_rights, $clang_id))
            {
                $kick = "#".$id;
                //schneid die id aus dem string raus (inkl Hashtag: #)
                $trimmed = str_replace($kick, "", $wildcards_rights);
                //führe SQL aus
                $sql_trimmed = rex_sql::factory();   
                $sql_trimmed->setQuery('UPDATE rex_user SET wildcards_rights="'.$trimmed.'" WHERE user_id='.$user_id);
            }

            $sql->next();
        }
    }


    // EP zum Hinzufügen des Datatables Plugins & page interne Scripts
    if(rex_request('page') == 'wildcards') {
        rex_register_extension('PAGE_HEADER', 'AddDataTablejs');
    }
    function AddDataTablejs($params) {
        $out = '<!--- jQuery UI and X-editable --->
                <script type="text/javascript" src="/files/addons/wildcards/js/jquery-1.10.2.js"></script>
                <script type="text/javascript" src="/files/addons/wildcards/js/jquery-ui.js"></script>
                <link href="/files/addons/wildcards/css/jquery-ui.min.css" rel="stylesheet"/>
                <script type="text/javascript" src="/files/addons/wildcards/js/jqueryui-editable.min.js"></script>
                <link href="/files/addons/wildcards/css/jqueryui-editable.css" rel="stylesheet"/>
                <link href="/files/addons/wildcards/css/page-style/table-style.css" rel="stylesheet"/>';
        echo $out;

        //falls man sich im Unterfenster Users befindet
        if(rex_request('subpage') == 'users'){
            echo '<script type="text/javascript" src="/files/addons/wildcards/js/page-script/users-script.js"></script>';
            echo '<link href="/files/addons/wildcards/css/page-style/users-style.css" rel="stylesheet"/>';
        }
        //falls man sich im Unterfenster Settings befindet
        if(rex_request('subpage') == 'settings'){
            echo '<script type="text/javascript" src="/files/addons/wildcards/js/page-script/settings-script.js"></script>';
        }
    }


    // Aufruf eines EP (Funktion) wenn index.php?page=wildcards&ajaxout=1  ist
    if((rex_request('page') == 'wildcards') && (rex_request('ajaxout') == 1)) {
        rex_register_extension('OUTPUT_FILTER', 'AjaxWildcardDataOut');
    }
    //Funktionsaufruf Ajax
    function AjaxWildcardDataOut($params) {
        global $REX; // falls benötigt
    
        //Startet Ausgabebuffer
        ob_start();
        //führt Server Script aus um json zu erzeugen
        include( $REX['INCLUDE_PATH'].'/addons/wildcards/data/post.php' );
        exit; //Beendet Ausgabebuffer
    }

    // Aufruf eines EP (Funktion) wenn Session Variable veränder (neu definiert) werden soll
    if((rex_request('page') == 'wildcards') && (rex_request('sessionout') == 1)) {
        rex_register_extension('OUTPUT_FILTER', 'functionWildcards_Session');
    }
    //Funktionsaufruf Ajax
    function functionWildcards_Session($params) {
        global $REX; // falls benötigt
    
        //Startet Ausgabebuffer
        ob_start();
        //führt Server Script aus und setzt Session Var
        include( $REX['INCLUDE_PATH'].'/addons/wildcards/data/session.php' );
        exit; //Beendet Ausgabebuffer
    }


?>